<?php

session_start();
include('check.php');
include('functions.php');

if( !is_dir('../pages') ){
  init_pages();
 }

$subpath = $_GET['path'];
if( $subpath )
  $dirpath = '../pages/'.$subpath;
else
  $dirpath = '../pages';
$dirlist = $dirpath.'/dir.list';
$trash_dirlist = '../pages/trash/dir.list';
$trash_dirpath = '../pages/trash';
$name = $_GET['name'];
$msg = $_GET['msg'];

$op = $_GET['op'];
if( $op ){
	switch( $op ){

	case 'reorder':
    $direction = $_GET['direction'];
    reorder($name, $dirpath, $direction);
    break;

  case 'del':
    $res = del_file($name, $dirpath);
    if( $res ) $msg = 'Ok';
    else $msg = 'Can not move item to trash';
    break;

  case 'destroy':
    $res = del_file($name, '../pages/trash');
    if( $res ) $msg = 'Ok';
    else $msg = 'Can not delete item from trash';
    break;
    
  case 'cp':
    copy_item($name, $dirpath);
    break;

  case 'paste':
    paste_item($dirpath);
    break;

  case 'restore':
    restore_file($name, $dirpath);
    break;

  case 'status':
    $newstatus = $_GET['newstatus'];
    change_status($name, $dirpath, $newstatus);
    break;

  case 'newitem':
    foreach(Array('newpage', 'newfolder', 'newimage', 'newlink') as $v){
      $isitem = $_POST[$v];
      if( $isitem ){
	$newname = $_POST[$v.'name'];
	switch( $v ){

	case 'newpage':
	  new_page($newname, $dirpath);
	  break;

	case 'newfolder':
	  new_folder($newname, $dirpath);
	  break;

	case 'newimage':
	  $imagefile = $_FILES['imagefile'];
	  if( is_uploaded_file($imagefile['tmp_name']) ) new_image($imagefile, $dirpath);
	  else die('image upload failed...');
	  break;

	case 'newlink':
	  $newlinkhref = $_POST['newlinkhref'];
	  new_link($newlinkhref, $dirpath);
	  break;

	}
      }
    }
    break;

  case 'newother':
    $othername = $_POST['newothername'];
    switch($othername){

    case 'guestbook':
      include('others/guestbook/functions.php');
      new_guestbook($dirpath);
      break;

    case 'formpage':
      include('others/formpage/functions.php');      
      new_formpage($dirpath);
      break;

    }
    break;

  }
  header('location: index.php?path='.$subpath);
 }

?>


<html>

<head>

<title>MidiCMS Management</title>

<link rel="stylesheet" type="text/css" media="all" href="admin_style.css" />
<script src="jscripts/prototype.js" type="text/javascript"></script>
<script src="jscripts/scriptaculous.js" type="text/javascript"></script>
	
</head>
<body>

<table>
  <tr>
  <td>

  <fieldset>
    <legend>Items in the catalog pages</legend>

    <table class="listing" summary="File listing" cellpadding="0" cellspacing="0">
    <thead>

    <tr>
	<th>Object</th>
	  <th>Title</th>
	  <th>Active</th>
	  <th>Ordering</th>
	  <th>Action</th>
	</tr> 
      </thead>
      <tbody id="list_dir">

<?php

if( !is_file($dirlist) ) create_dirlist($dirlist);
$rows = file($dirlist);

if( $subpath ){
  $pathtkns = split('/', $subpath);
  $parentpath = implode('/', array_slice($pathtkns, 0, sizeof($pathtnks)-1));
  echo '<tr class="odd" id="item_0">';
  echo '<td>'; // name
  echo '<a href="?path='.$parentpath.'">';
  echo '<img src="images/folder_icon.gif" border="0" alt="ico" />';
  echo '</a>..';
  echo '</td>';
  echo '<td>&nbsp;</td>'; // title
  echo '<td>&nbsp;</td>'; // status
  echo '<td>&nbsp;</td>'; // order
  echo '<td>&nbsp;</td>'; // action
  echo '</tr>';
 }

$even = true;
$first = true;
$last = false;
$n = count($rows);
for( $i=0; $i<$n; $i++ ){
  $a = split("\|", $rows[$i]);
  $file = $a[0];
  $title = $a[1];
  $status = $a[2];
  $isfolder = false;
  $toedit = false;

  $a2 = split("\.", $file);
  $ext = $a2[1];

  if( $i == $n-1 ) $last = true;

  if( $file == 'trash' ) $ico = 'trash_icon.gif';
  elseif( is_dir("$dirpath/$file") ){
    $ico = 'folder_icon.gif'; 
    $isfolder = true;
  }
  $ico = get_icon($file);
  if( $ext == 'html' || $ext =='sign' ) $toedit = true;

  if( $file != '.' and $file != '..' ){

    /*
    if( $even ) echo '<tr class="even">';
    else echo '<tr class="evev" id="'.$file.'">';
    */
    echo '<tr class="even" id="item_'.$i.'">';


    echo '<td nowrap="nowrap">';
    if( $isfolder ){
      if( $subpath )  echo '<a href="?path='.$subpath.'/'.$file.'">';
      else  echo '<a href="?path='.$file.'">';
    }
    elseif( $toedit ) echo '<a href="../?html='.$file.'" target="_blank">';
    else echo '<a href="'.$dirpath.'/'.$file.'">';
    echo '<img src="images/'.$ico.'" border="0" alt="" /></a>';
    echo ' <span id="name_'.$file.'" style="">'.$file;
    echo '</span></td>';

    echo '<td>';
    if( $toedit or $isfolder ){
      echo '<span id="title_'.$file.'">';
      echo $title.'</span>';
      echo '<script type="text/javascript">new Ajax.InPlaceEditor("title_'.$file.'", "save.php?what=title&title=1&path='.$dirpath.'&p='.$file.'", {okButton:true, cancelText:"[x]"});</script>';
    }
    else echo $title;
    echo '</td>';

    echo '<td align="center">';
    if( $status == '1' ){
      echo '<a href="?path='.$subpath.'&op=status&name='.$file.'&newstatus=0"><img src="images/active_icon.gif" border="0" /></a>';
    } else {
      echo '<a href="?path='.$subpath.'&op=status&name='.$file.'&newstatus=1"><img src="images/inactive_icon.gif" border="0" /></a>';
    }
    echo '</td>';

    echo '<td valign="middle" align="center">';
    if( !$first ){
      echo '<a href="?path='.$subpath.'&op=reorder&name='.$file.'&direction=up"><img src="images/up_icon.gif" border="0" /></a>';
    }
    echo '&nbsp;&nbsp;';
    if( !$last ){
      echo '<a href="?path='.$subpath.'&op=reorder&name='.$file.'&direction=down"><img src="images/down_icon.gif" border="0" /></a>';
    }
    echo '</td>';
    

    echo '<td align="center" nowrap="nowrap">';
    if( $toedit ) echo '<a href="edit.php?path='.$subpath.'&name='.$file.'"><img src="images/edit_icon.gif" border="0" /></a> ';
    if( !$isfolder ) echo '';
    else echo '<a href="configure.php?path='.$subpath.'&name='.$file.'"><img src="images/empty_icon.gif" border="0" /></a> ';
    echo '<a href="?path='.$subpath.'&op=del&name='.$file.'"><img src="images/trash_icon.gif" border="0" /></a>';
    echo '</td>';

    echo '</tr>';

    if( $first) $first = false;
    $even = !$even;

  }
 }
?>

      </tbody>
    </table>



    <div id="out"></div>


    
    <table>
	  <tr><td align="center"><img src="images/document_icon.gif" border="0" /></td>
          <td>
            <div class="formHelp"> Click this icon to open page in a new window</div>
          </td></tr>
  <tr><td align="center"><img src="images/active_icon.gif" border="0" /> <img src="images/inactive_icon.gif" border="0" /></td>
          <td>
            <div class="formHelp"> Change visibility (If the page is shown in menu, or be hidden)</div>
          </td></tr>
  <tr><td align="center"><img src="images/edit_icon.gif" border="0" /></td>
          <td><div class="formHelp">Change the content in HTML page</div></td></tr>

      <tr><td align="center"><img src="images/trash_icon.gif" border="0" /></td>
          <td>
            <div class="formHelp">Move side to the trash</div>
          </td></tr>
  <tr><td align="center"><img src="images/up_icon.gif" border="0" /> <img src="images/down_icon.gif" border="0" /></td>
          <td>
            <div class="formHelp"> Change the sort of pages in the menu (Not home page index.html)</div>
          </td></tr>
		  <tr><td>&nbsp;</td>
 <td>
            <div class="formHelp"> <b>Create a new HTML page</b><br>
              Use only short file names in lower case without spaces
</div>
</td>
</tr>
  <tr><td align="center"></td>
          <td>
            <div class="formHelp"> <b>Amendment to the HTML page title (the clickable
               link in the menu, does not apply to home page)</b><br>
              Click on the current title, enter a new title and press ok<BR>
  </div>
          </td></tr>
<tr><td>&nbsp;</td>
 <td>
            <div class="formHelp"> <b>File Manager</b><br>
              Using this tool, you upload, modify and
               delete images, media files and documents.<br>
              The directory uploads there are 4 sub-folders, docs, files, images
               and the media.</div>
</td>
</tr>

</table>

  </fieldset>

  </td><td>

  <!-- trash folder -->
  <fieldset>
    <legend>Items in the Trash</legend>

    <table class="listing" summary="Item in trash" cellpadding="0" cellspacing="0">
      <thead>
        <tr>
	  <th>Object</th>
	  <th>Title</th>
	  <th>Action</th>
	</tr> 
      </thead>
      <tbody>

<?php

$rows = file($trash_dirlist);
$even = true;
$n = count($rows);
for( $i=0; $i<$n; $i++ ){
  $a = split("\|", $rows[$i]);
  $file = $a[0];
  $title = $a[1];
  if( $file == 'trash' ) $ico = 'trash_icon.gif';
  elseif( is_dir($trash_dirpath.'/'.$file) ){
    $ico = 'folder_icon.gif'; 
    $isfolder = true;
  }
  else $ico = get_icon($file);

  if( $file != '.' and $file != '..' ){
    
    if( $even ) echo '<tr class="even">';
    else echo '<tr class="even">';

    // page
    echo '<td>';
    echo '<img src="images/'.$ico.'" border="0" alt="ico" />';
    echo $file;
    echo '</td>';

    // title
    echo '<td>'.$title.'</td>';


    // action
    echo '<td>';
    echo '<a href="?path='.$subpath.'&op=destroy&name='.$file.'"><img src="images/del_icon.gif" border="0" /></a>';
    echo '<a href="?path='.$subpath.'&op=restore&name='.$file.'"><img src="images/restore_icon.gif" border="0" /></a>';
    echo '</td>';

    echo '</tr>';
    $even = !$even;
  }
 }
?>

      </tbody>
    </table>

    <table>
      <tr><td align="center"><img src="images/del_icon.gif" border="0" /></td>
          <td><div class="formHelp"> Delete item</div></td></tr>
      <tr><td align="center"><img src="images/restore_icon.gif" border="0" /></td>

          <td><div class="formHelp"> Re-create the object</div></td></tr>


    </table>

  </fieldset>

  <form action="<?php echo '?path='.$subpath; ?>&op=newitem" method="post" enctype="multipart/form-data">
        <!-- add item -->
  <fieldset> <legend>Create a new HTML page</legend> 
        <div>
            
          <div class="formHelp">Short filenames without spaces</div>
              
	    <input type="text" name="newpagename" id="newpagename" size="25" /><br><br>
	    <input type="submit" class="button" name="newpage" id="newpage" value="Create HTML page" />
        </div>
  </fieldset>

  </form>
  
      <fieldset> <legend>File Management</legend> 
      <div>
            
        <div class="formHelp">Upload / edit and delete files</div>
<FORM METHOD="GET" ACTION="jscripts/tiny_mce/plugins/ezfilemanager/" TARGET="_blank"><input type="submit" class="button" value="Open File Manager"></FORM>
        </div>
  </fieldset>
  
      <fieldset> <legend>Complete Management</legend> 
        <div>
            
<FORM METHOD="GET" ACTION="logout.php"><input type="submit" class="button" value="Log Out"></FORM>
        </div>
  </fieldset>

  

  </td>
  </tr>

  <tr>
  <td colspan=2>



  </td></tr>
</table>

  
</body>
</html>
